<?php
/**
 * @package Sj Responsive Listing for Virtuemart
 * @version 3.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */

defined('_JEXEC') or die;

require_once dirname(__FILE__).'/vmloader.php';
require_once dirname(__FILE__).'/helper_base.php';
	
 class VmResponsiveListingHelper extends VmResponsiveListingBaseHelper {
	public static $total = null;
	protected static $featured =  null;
	public static function getList($params){
	
		if(!class_exists('VmConfig')) return;
		VmConfig::loadConfig ();
		JFactory::getLanguage ()->load ('com_virtuemart');
		$items = array();
		$list = array();
		$retur = array();
		$catids = $params->get('catid');
		settype($catids, 'array');
		$catidpreload = $params->get('catid_preload');
		$limitation = (int)$params->get('source_limit',8);
		$desc_maxlength = $params->get('item_des_maxlength_layout_grid',250);
		$source_order = $params->get('source_order');
		$itemsOrdering_display = $params->get('itemsOrdering_display');
		if(!empty($itemsOrdering_display) && !in_array($source_order,$itemsOrdering_display)){
			$source_order = $itemsOrdering_display[0];
		}
		
		$source_group = null;
		$ordering_direction = $params->get('article_ordering_direction');
		$p_special =  $params->get('show_front');
		self::$featured = $p_special;
		$categories = array();
		$cat_order_by = $params->get('category_ordering','title');
		$categoryModel = VmModel::getModel('Category');
		if(!empty($catids)){
			$__catids = array();
			$getcatids = array();
			
			$app = JFactory::getApplication();
			$option = $app->input->get('option');
			$view = $app->input->get('view');
			$mode = $params->get('mode', 'normal');
			$dy_catid = array();
			$flag = false;
			switch ($mode){
				case 'dynamic':
					if ($option === 'com_virtuemart' && $view === 'category' ) {
						$dy_catid = array($app->input->getInt('virtuemart_category_id'));
						$return_cat = self::_processCategories($dy_catid,$cat_order_by);
						$list = $return_cat['list_cat'];
						$getcatids = $return_cat['getcatids'];
						$flag = true;	
					}else {
						$return_cat = self::_processCategories($catids,$cat_order_by);
						$list = $return_cat['list_cat'];
						$getcatids = $return_cat['getcatids'];
					}
			
					break;
			
				case 'normal':
				default:
					$return_cat = self::_processCategories($catids,$cat_order_by);
					$list = $return_cat['list_cat'];
					$getcatids = $return_cat['getcatids'];
				break;
			}
			
			
			$retur['categories'] = $list;
			self::$total = self::_getTotalProducts($getcatids);
			$productModel = new VirtuemartModelProductExtend();
			$productModel->filter_order = $source_order;
			$productModel->specail_product = $p_special;
			$productModel->ordering_direction = $ordering_direction;
			$ratingModel = VmModel::getModel('ratings');
			$items = $productModel->getProductListing( $source_group,$limitation , true, true, false, true, $getcatids );
			if(!empty($items)) {
				$productModel->addImages($items);
				foreach($items as $item){
					$category = $categoryModel->getCategory($item->virtuemart_category_id, false);
					$category = $list[$item->virtuemart_category_id];
					//var_dump($item->virtuemart_category_id);
					if(isset($category->count)){
						$category->count ++;
					}else{
						$category->count = 1;
					}
					$item->vote = $ratingModel->getVoteByProduct($item->virtuemart_product_id);
					$item->rating = $ratingModel->getRatingByProduct($item->virtuemart_product_id);
					$item->id = $item->virtuemart_product_id;
					$item->title = $item->product_name;	
					$item->category_title = $category->category_name;
					$item->catid = $category->virtuemart_category_id;
					$item->catlink = JRoute::_('index.php?option=com_virtuemart&view=category&virtuemart_category_id='.$item->virtuemart_category_id);
					$item->description = $item->product_desc;
					self::getVmImages($item, $params);
					$item->short_desc =  $item->product_s_desc;
					//$item->short_desc = ($item->short_desc !='')?self::truncate($item->short_desc,$desc_maxlength):self::truncate($item->short_desc,$desc_maxlength);
					$item->_description =  self::_cleanText($item->description);
					$item->_description = ($item->_description !='')?$item->_description:$item->short_desc;
					//$list[] = $item;
				} 
			}else{
				return ;
			}
			
			if ($params->get('tab_all_display', 1)){
				$all = new stdClass();
				$all->id = '*';
				$all->count = count($items);
				$all->title = JText::_('ALL_LABEL');
			
				array_unshift($retur['categories'], $all);
			}
			// default select
			$selected = false;
			foreach ($retur['categories'] as $cat){
				if ( ($cat->id == $catidpreload || (!empty($dy_catid) && $flag && $cat->id  == $dy_catid[0]) ) && $cat->count > 0 ){
					$cat->sel = 'sel';
					$selected = true;
				}
			}
			// first tab is active
			if (!$selected){
				foreach ($retur['categories'] as $cat){
					if ($cat->count > 0){
						$cat->sel = 'sel';
						break;
					}
				}
			}
			
			$retur['items'] = $items;
			return $retur;
		}
			
	}
	
	private static function _processCategories($catids,$cat_order_by){
		$__catids = array();
		$getcatids = array();
		$list = array();
		$retur_cat = array();
		$_list = array();
		$_catids = array();
		$categoryModel = VmModel::getModel('Category');
		$categories =	$categoryModel->getCategories( true, false ,false,'' );
		foreach($categories as $_category){
			$_catids[] = $_category->virtuemart_category_id;
		}
		foreach($catids  as $cat){
			if(in_array($cat,$_catids )){
				$__catids[] = $cat;				 
			}
		}
		foreach($__catids  as $_cat){
			$category = $categoryModel->getCategory($_cat, false);
			$list[] = $category;
			switch($cat_order_by){
				default:
				case 'title':
					usort($list, create_function('$a, $b', 'return strnatcasecmp( $a->category_name, $b->category_name);'));
					break;
				case 'ordering':	
					usort($list, create_function('$a, $b', 'return $a->ordering < $b->ordering;'));
					break;
				case 'random':
					shuffle($list);
					break;
			}	
		}
		foreach($list as $tem){
			$tem->count = 0;
			$tem->id = $tem->virtuemart_category_id;
			$tem->title = $tem->category_name;
			$_list[$tem->virtuemart_category_id] = $tem;
			$getcatids[] = $tem->virtuemart_category_id;
		}
		$retur_cat['list_cat'] = $_list;
		$retur_cat['getcatids'] = $getcatids;
		return $retur_cat;
	}
	
	public static function _getTotalProducts($ids){
		$count_product = 0;
		if(!empty($ids)){
			foreach($ids as $id){
				$count_product += self::_countProducts($id);
			}
		}
		return $count_product;
	}
	
	private static function _countProducts($cat_id=0) {
		$_db = JFactory::getDBO();
		$vendorId = 1;
		if ($cat_id > 0) {
			$q = 'SELECT count(`#__virtuemart_products`.`virtuemart_product_id`) AS total
			 FROM `#__virtuemart_products` LEFT JOIN `#__virtuemart_product_categories` ON `#__virtuemart_products`.`virtuemart_product_id` = `#__virtuemart_product_categories`.`virtuemart_product_id` LEFT JOIN `#__virtuemart_product_shoppergroups` ON `#__virtuemart_products`.`virtuemart_product_id` = `#__virtuemart_product_shoppergroups`.`virtuemart_product_id` LEFT OUTER JOIN `#__virtuemart_shoppergroups` as s ON s.`virtuemart_shoppergroup_id` = `#__virtuemart_product_shoppergroups`.`virtuemart_shoppergroup_id`
			 WHERE ( `#__virtuemart_products`.`published`="1" AND `#__virtuemart_product_categories`.`virtuemart_category_id` = '.(int)$cat_id.' AND `#__virtuemart_product_categories`.`virtuemart_category_id`  > 0 AND ( s.`virtuemart_shoppergroup_id`= "1" OR s.`virtuemart_shoppergroup_id` IS NULL ) )  ';
			
			switch (self::$featured ){
				case 'hide':
					$q .= ' AND `#__virtuemart_products`.`product_special` = "0"'; // TODO Change  to  a  individual button
					break;
				case 'only':
					$q .= ' AND `#__virtuemart_products`.`product_special` = "1"'; // TODO Change  to  a  individual button
					$orderBy = 'ORDER BY RAND()';
					break;
				case 'show':
				default:
					// Normally we do not discriminate
					// between featured/unfeatured items.
					break;
			}
			$_db->setQuery($q);
			$count = $_db->loadResult();
		} else $count=0 ;

		return $count;
	}
	
}


if(!class_exists('VirtuemartModelProductExtend') && class_exists('VirtueMartModelProduct')){
	class VirtuemartModelProductExtend extends VirtueMartModelProduct{
		function sortSearchListQuery ($onlyPublished = TRUE, $virtuemart_category_id = FALSE, $group = FALSE, $nbrReturnProducts = FALSE) {
			$app = JFactory::getApplication ();
			$groupBy = ' group by p.`virtuemart_product_id` ';

			$joinCategory = FALSE;
			$joinMf = FALSE;
			$joinPrice = FALSE;
			$joinCustom = FALSE;
			$joinShopper = FALSE;
			$joinChildren = FALSE;
			$joinLang = TRUE;
			$orderBy = ' ';

			$where = array();
			$useCore = TRUE;
			if ($useCore) {
				$isSite = $app->isSite ();
				if ($onlyPublished) {
					$where[] = ' p.`published`="1" ';
				}
				if($isSite and !VmConfig::get('use_as_catalog',0)) {
					if (VmConfig::get('stockhandle','none')=='disableit_children') {
						$where[] = ' (p.`product_in_stock` - p.`product_ordered` >"0" OR children.`product_in_stock` - children.`product_ordered` > "0") ';
						$joinChildren = TRUE;
					} else if (VmConfig::get('stockhandle','none')=='disableit') {
						$where[] = ' p.`product_in_stock` - p.`product_ordered` >"0" ';
					}
				}
			
				if ( $virtuemart_category_id !== false ){
					$joinCategory = TRUE ;
					
					if ( is_string($virtuemart_category_id) && preg_match('/[\s|,]+/', $virtuemart_category_id)){
						$virtuemart_category_id = preg_split('/[\s|,]+/', $virtuemart_category_id);
					}
					if ( !is_array($virtuemart_category_id) ){
						settype($virtuemart_category_id, 'array');
					}
					
					$where[] = ' `pc`.`virtuemart_category_id` IN ('.implode(',', $virtuemart_category_id).')';
					
				}

				if ($isSite and !VmConfig::get('show_uncat_child_products',TRUE)) {
					$joinCategory = TRUE;
					$where[] = ' `pc`.`virtuemart_category_id` > 0 ';
				}

				if ($this->product_parent_id) {
					$where[] = ' p.`product_parent_id` = ' . $this->product_parent_id;
				}

				if ($isSite) {
					$usermodel = VmModel::getModel ('user');
					$currentVMuser = $usermodel->getUser ();
					$virtuemart_shoppergroup_ids = (array)$currentVMuser->shopper_groups;

					if (is_array ($virtuemart_shoppergroup_ids)) {
						$sgrgroups = array();
						foreach ($virtuemart_shoppergroup_ids as $key => $virtuemart_shoppergroup_id) {
							$sgrgroups[] = 's.`virtuemart_shoppergroup_id`= "' . (int)$virtuemart_shoppergroup_id . '" ';
						}
						$sgrgroups[] = 's.`virtuemart_shoppergroup_id` IS NULL ';
						$where[] = " ( " . implode (' OR ', $sgrgroups) . " ) ";

						$joinShopper = TRUE;
					}
				}

				if ($this->virtuemart_manufacturer_id) {
					$joinMf = TRUE;
					$where[] = ' `#__virtuemart_product_manufacturers`.`virtuemart_manufacturer_id` = ' . $this->virtuemart_manufacturer_id;
				}
				
				switch ($this->specail_product){
					case 'hide':
						$where[] = ' p.`product_special`="0" '; 
						break;

					case 'only':
						$where[] = ' p.`product_special`="1" '; 
						break;

					case 'show':
					default:
						break;
				}
				
				$this->filter_order_Dir = $this->ordering_direction;
				
				if($this->filter_order){
					switch ($this->filter_order) {
						default:
						case 'id':
							$orderBy = ' ORDER BY p.`virtuemart_product_id` ';
							break;
						case 'ordering':
							$orderBy = ' ORDER BY `pc`.`ordering` ';
							$joinCategory = TRUE;
							break;
						case 'product_name':
							$orderBy = ' ORDER BY `product_name` ';
							$joinPrice = TRUE;
							break;
						case 'product_price':
							$orderBy = ' ORDER BY `product_price` ';
							$joinPrice = TRUE;
							break;	
						case 'created_on':
							$orderBy = ' ORDER BY p.`created_on` ';
							break;
						case 'latest':
							$orderBy = 'ORDER BY p.`modified_on`';
							break;
						case 'topten':
							$orderBy = ' ORDER BY p.`product_sales` '; 
							$where[] = 'pp.`product_price`>"0.0" ';
							break;
						
					}
					$joinPrice = TRUE;
				}
				if ($group) {
					$groupBy = 'group by p.`virtuemart_product_id` ';
				}
			}

			if ($joinLang) {
				$select = ' l.`virtuemart_product_id` FROM `#__virtuemart_products_' . VMLANG . '` as l';
				$joinedTables = ' JOIN `#__virtuemart_products` AS p using (`virtuemart_product_id`)';
			}
			else {
				$select = ' p.`virtuemart_product_id` FROM `#__virtuemart_products` as p';
				$joinedTables = '';
			}

			if ($joinCategory == TRUE) {
				$joinedTables .= ' LEFT JOIN `#__virtuemart_product_categories` as pc ON p.`virtuemart_product_id` = `pc`.`virtuemart_product_id`
				 LEFT JOIN `#__virtuemart_categories_' . VMLANG . '` as c ON c.`virtuemart_category_id` = `pc`.`virtuemart_category_id`';
			}
			if ($joinMf == TRUE) {
				$joinedTables .= ' LEFT JOIN `#__virtuemart_product_manufacturers` ON p.`virtuemart_product_id` = `#__virtuemart_product_manufacturers`.`virtuemart_product_id`
				 LEFT JOIN `#__virtuemart_manufacturers_' . VMLANG . '` as m ON m.`virtuemart_manufacturer_id` = `#__virtuemart_product_manufacturers`.`virtuemart_manufacturer_id` ';
			}

			if ($joinPrice == TRUE) {
				$joinedTables .= ' LEFT JOIN `#__virtuemart_product_prices` as pp ON p.`virtuemart_product_id` = pp.`virtuemart_product_id` ';
			}
			if ($this->searchcustoms) {
				$joinedTables .= ' LEFT JOIN `#__virtuemart_product_customfields` as pf ON p.`virtuemart_product_id` = pf.`virtuemart_product_id` ';
			}
			if ($this->searchplugin !== 0) {
				if (!empty($PluginJoinTables)) {
					$plgName = $PluginJoinTables[0];
					$joinedTables .= ' LEFT JOIN `#__virtuemart_product_custom_plg_' . $plgName . '` as ' . $plgName . ' ON ' . $plgName . '.`virtuemart_product_id` = p.`virtuemart_product_id` ';
				}
			}
			if ($joinShopper == TRUE) {
				$joinedTables .= ' LEFT JOIN `#__virtuemart_product_shoppergroups` ON p.`virtuemart_product_id` = `#__virtuemart_product_shoppergroups`.`virtuemart_product_id`
				 LEFT  OUTER JOIN `#__virtuemart_shoppergroups` as s ON s.`virtuemart_shoppergroup_id` = `#__virtuemart_product_shoppergroups`.`virtuemart_shoppergroup_id`';
			}

			if ($joinChildren) {
				$joinedTables .= ' LEFT OUTER JOIN `#__virtuemart_products` children ON p.`virtuemart_product_id` = children.`product_parent_id` ';
			}

			if (count ($where) > 0) {
				$whereString = ' WHERE (' . implode (' AND ', $where) . ') ';
			}
			else {
				$whereString = '';
			}

			$this->orderByString = $orderBy;
			$product_ids = $this->_exeSortSearchListQuery (2, $select, $joinedTables, $whereString, $groupBy, $orderBy, $this->filter_order_Dir, $nbrReturnProducts);
			return $product_ids;

		}
		
		public function _exeSortSearchListQuery($object, $select, $joinedTables, $whereString = '', $groupBy = '', $orderBy = '', $filter_order_Dir = '', $nbrReturnProducts = false){
			$joinedTables .= $whereString .$groupBy .$orderBy .$filter_order_Dir ;
			$q = 'SELECT '.$select.$joinedTables;
			$app = JFactory::getApplication();
			$limitStart = $app->input->getInt('ajax_reslisting_start',0);	
			$limit = $nbrReturnProducts;
			if(empty($limit)){
				$this->_db->setQuery($q);
			} else {
				$this->_db->setQuery($q,$limitStart,$limit);
			}
//echo $q;die;
			if($object == 2){
				 $this->ids = $this->_db->loadResultArray();
			} else if($object == 1 ){
				 $this->ids = $this->_db->loadAssocList();
			} else {
				 $this->ids = $this->_db->loadObjectList();
			}
			if($err=$this->_db->getErrorMsg()){
				vmError('exeSortSearchListQuery '.$err);
			}

			$this->_db->setQuery('SELECT FOUND_ROWS()');
			$count = $this->_db->loadResult();

			if($count == false){
				$count = 0;
			}
			$this->_total = $count;
			if($limitStart>=$count){
				if(empty($limit)){
					$limit = 1.0;
				}
				$limitStart = floor($count/$limit);
				$this->_db->setQuery($q,$limitStart,$limit);
				if($object == 2){
					$this->ids = $this->_db->loadResultArray();
				} else if($object == 1 ){
					$this->ids = $this->_db->loadAssocList();
				} else {
					$this->ids = $this->_db->loadObjectList();
				}
			}

			if(empty($this->ids)){
				$errors = $this->_db->getErrorMsg();
				if( !empty( $errors)){
					vmdebug('exeSortSearchListQuery error in class '.get_class($this).' sql:',$this->_db->getErrorMsg());
				}
				if($object == 2 or $object == 1){
					$this->ids = array();
				}
			}
			return $this->ids;

		}

	}
}	