<?php
/**
 * @package Sj Responsive Listing for Virtuemart
 * @version 3.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */

defined('_JEXEC') or die;
$currency = CurrencyDisplay::getInstance();
if(isset($list['items'])) {
ImageHelper::setDefault($params);
foreach($list['items']  as $item){  ?>
	<div class="respl-item first-load category-<?php echo $item->catid ?>"  
		data-product_price="<?php echo $item->prices['salesPrice']; ?>" 
		data-created="<?php echo strtotime($item->created_on) ?>" 
		data-latest="<?php echo ($item->modified_on != '')?strtotime($item->modified_on):0; ?>" 
		data-ordering="<?php echo $item->ordering; ?>" 
		data-topten="<?php echo $item->product_sales; ?>" 
		data-title="<?php echo mb_strtolower($item->title); ?>" 
		data-id="<?php echo $item->id; ?>" 
		data-catid="<?php echo $item->catid ?>">
		<div class="item-inner">
			<?php $img = VmResponsiveListingHelper::getVmImage($item, $params);  
			if($img && (@GetImageSize($img['src']) || file_exists($img['src']))) {?>
			<div class="item-image cf">
				<?php if($params->get('item_cat_display', 1) == 1){?>
				<div class="item-public" data-value="<?php echo JText::_('PUBLISHED_LABEL')?>">&nbsp;
					<a href="<?php echo $item->catlink ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->category_title?>" >
						<?php echo $item->category_title?>
					</a>
				</div>
				<?php }?>
					<a href="<?php echo $item->link ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->title?>" >
						<?php   echo VmResponsiveListingHelper::imageTag($img);?>
					<?php if($params->get('item_cat_display', 1) == 1){?>
					<span class="item-opacity"></span>
					<?php }?>
					</a>
			</div>
			<?php }
			if($params->get('item_title_display',1) == 1){?>
			<div class="item-title ">
				<a href="<?php echo $item->link ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->title?>" >
					<?php echo VmResponsiveListingHelper::truncate($item->title, $params->get('item_title_max_characters',25)); ?>
				</a>
			</div>
			<?php }?>
			<?php if($params->get('item_created_display', 1)== 1) {?>
			<div class="item-post-read">
				<?php if($params->get('item_created_display',1) == 1) {?>
				<div class="item-post" data-value="<?php echo JText::_('POST_LABEL')?>">&nbsp;<?php echo  JHTML::_('date', $item->created_on,JText::_('DATE_FORMAT_LC3')) ?></div>
				<?php }?>
			</div>
			<?php } 
			if($params->get('item_description_display', 1) == 1 && VmResponsiveListingHelper::_trimEncode($item->_description) != '') {?>
			<div class="item-desc">
				<?php
					echo VmResponsiveListingHelper::truncate($item->_description, (int)$params->get('item_des_maxlength_layout_list'));
				?>
			</div>
			<?php }
			if($params->get('item_rating_display',1)){
				$maxrating = VmConfig::get('vm_maximum_rating_scale', 5);
				if (empty($item->rating)) { ?>
					<span class="item-vote">
						<?php echo JText::_('COM_VIRTUEMART_RATING') . ' ' . JText::_('COM_VIRTUEMART_UNRATED') ?>
					</span>
				<?php } else { $ratingwidth = $item->rating->rating * 24; ?>
					<span class="item-vote">
						<span title=" <?php echo (JText::_("COM_VIRTUEMART_RATING_TITLE") . round($item->rating->rating) . '/' . $maxrating) ?>" class="ratingbox" style="display:inline-block;">
							<span class="stars-orange" style="width:<?php echo $ratingwidth.'px'; ?>"></span>
						</span>
					</span>
				<?php }
			}
			if((int)$params->get('item_price_display',1)){ ?>
			<div class="item-price">
				<?php
				if (!empty($item->prices['salesPrice'])) {
					echo $currency->createPriceDiv ('salesPrice', '', $item->prices, FALSE, FALSE, 1.0, TRUE);
				}
				if (!empty($item->prices['salesPriceWithDiscount'])) {
					echo $currency->createPriceDiv ('salesPriceWithDiscount', '', $item->prices, FALSE, FALSE, 1.0, TRUE);
				} ?>
			</div>
			<?php } 
			 if($params->get('item_readmore_display', 1) == 1){?>
			<div class="item-readmore">
				<a href="<?php echo $item->link ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->title?>" data-arrow="&#187;" >
					<?php echo JText::_('READ_MORE_LIST_LABEL') ?>
				</a>
			</div>
			<?php } ?>
			<div class="item-more">
				<?php if($img && (@GetImageSize($img['src']) || file_exists($img['src']))) {?>
				<div class="more-image cf">
					<a href="<?php echo $item->link ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->title?>" >
						<?php   echo VmResponsiveListingHelper::imageTag($img);?>
					</a>
				</div>
				<?php } ?>
				<div class="more-desc">
					<div class ="more-opacity"></div>
					<div class="more-inner">
						<?php if($params->get('item_title_display',1) == 1){?>
						<div class="more-title">
							<a href="<?php echo $item->link ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->title?>" >
								<?php echo VmResponsiveListingHelper::truncate($item->title, $params->get('item_title_max_characters',25)); ?>
							 </a>
							
						</div>
						<?php }?>
						<?php if($params->get('item_cat_display', 1) == 1){?>
						<div class="more-public" data-value="<?php echo JText::_('PUBLISHED_LABEL')?>">&nbsp;
							<a href="<?php echo $item->catlink ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->category_title?>" >
								<?php echo $item->category_title ?>
							</a>
						</div>
						<?php }?>
						<?php if($params->get('item_description_display', 1) == 1 && VmResponsiveListingHelper::_trimEncode($item->_description) != '') {?>
						<div class="more-content">
							<?php
								echo VmResponsiveListingHelper::truncate($item->_description, (int)$params->get('item_des_maxlength_layout_grid'));
							?>
					 	</div>
					 	<?php }
						if($params->get('item_rating_display',1)){
							$maxrating = VmConfig::get('vm_maximum_rating_scale', 5);
							if (empty($item->rating)) {
							?>
							<span class="more-vote"><?php echo JText::_('COM_VIRTUEMART_RATING') . ' ' . JText::_('COM_VIRTUEMART_UNRATED') ?></span>
							 <?php } else {
								$ratingwidth = $item->rating->rating * 24; //I don't use round as percetntage with works perfect, as for me
							 ?>
							<span class="more-vote">
								<span title=" <?php echo (JText::_("COM_VIRTUEMART_RATING_TITLE") . round($item->rating->rating) . '/' . $maxrating) ?>" class="ratingbox" style="display:inline-block;">
								<span class="stars-orange" style="width:<?php echo $ratingwidth.'px'; ?>">
								</span>
								</span>
							</span>
							<?php }	
						}	
						if((int)$params->get('item_price_display',1)){ ?>
						<div class="more-price">
							<?php
							if (!empty($item->prices['salesPrice'])) {
								echo $currency->createPriceDiv ('salesPrice', '', $item->prices, FALSE, FALSE, 1.0, TRUE);
							}
							if (!empty($item->prices['salesPriceWithDiscount'])) {
								echo $currency->createPriceDiv ('salesPriceWithDiscount', '', $item->prices, FALSE, FALSE, 1.0, TRUE);
							} ?>
						</div>
						<?php } 
						if($params->get('item_created_display',1) == 1) {?>
					 	<div class="more-post" data-value="<?php echo JText::_('POST_LABEL')?>"><?php echo  JHTML::_('date', $item->created_on,JText::_('DATE_FORMAT_LC3')) ?></div>
					 	<?php }?>
					 	<?php if($params->get('item_readmore_display', 1) == 1){?>
					 	<div class="more-readmore">
					 		<a href="<?php echo $item->link ?>" <?php echo VmResponsiveListingHelper::parseTarget($params->get('link_target','_self'))?> title="<?php echo $item->title?>" >
					 			<?php echo JText::_('READ_MORE_GRID_LABEL') ?>
					 		</a>
					 	</div>
					 	<?php }?>
				 	</div>
				 </div>
			</div>
		</div>
	</div>
<?php } 
} ?>
